﻿#NoEnv
#SingleInstance Force
SetBatchLines -1

global hToken := hCanvas := hPen := X1 := X2 := Y1 := Y2 := CountStart := CountEnd := 0
global GuiW := 1000, GuiH := 600, Rounds := 20000, GuiTitle := "GDI+ Performance Test"
global Q := DllCall("QueryPerformanceFrequency", "int64*", Frequency)

; ===============================================================================================================================

if !(DllCall("GetModuleHandle", "str", "GdiPlus", "ptr"))
    hGDIPLUS := DllCall("LoadLibrary", "str", "GdiPlus.dll", "ptr")
VarSetCapacity(SI, 24, 0), Numput(1, SI, 0, "Int")
if !(DllCall("GdiPlus.dll\GdiplusStartup", "ptr*", hToken, "ptr", &SI, "ptr", 0))
    hToken := hToken

; ===============================================================================================================================

Gui, +LastFound +hwndGDIExample
Gui, Show, % "w" GuiW " h" GuiH, % GuiTitle

DllCall("GdiPlus.dll\GdipCreateFromHWND", "ptr", GDIExample, "ptr*", hCanvas)
DllCall("Gdiplus.dll\GdipSetSmoothingMode", "ptr", hCanvas, "uint", 4)
DllCall("Gdiplus.dll\GdipCreatePen1", "uint", 0xFFFFFFFF, "float", 1, "int", 2, "ptr*", hPen)
DllCall("GdiPlus.dll\GdipGraphicsClear", "ptr", hCanvas, "uint", 0xFF000000)

DllCall("QueryPerformanceCounter", "int64*", CountStart)

loop % Rounds
{
    X1 := FRandom() * GuiW, X2 := FRandom() * GuiW, Y1 := FRandom() * GuiH, Y2 := FRandom() * GuiH
    , DllCall("GdiPlus.dll\GdipSetPenColor", "ptr", hPen, "uint", 0xFF000000 + IRandom())
    , DllCall("GdiPlus.dll\GdipDrawLine", "ptr", hCanvas, "ptr", hPen, "float", X1, "float", Y1, "float", X2, "float", Y2)
}

DllCall("QueryPerformanceCounter", "int64*", CountEnd)

WinSetTitle, % GuiTitle " / Created " Rounds " lines in " Round((CountEnd - CountStart) * 1000 / Frequency, 2) " ms."
return

; ===============================================================================================================================

GuiClose:
GuiEscape:
    DllCall("GdiPlus.dll\GdipDeletePen", "ptr", hPen)
    DllCall("GdiPlus.dll\GdipDeleteGraphics", "ptr", hCanvas)
    DllCall("GdiPlus.dll\GdiplusShutdown", "ptr", hToken)
    DllCall("FreeLibrary", "ptr", hGDIPLUS)
ExitApp

; ===============================================================================================================================

FRandom()
{
    SetFormat, FloatFast, 0.15
    Random, rand, 0.0, 1.0
    return rand
}

IRandom()
{
    Random, rand, 0, 0xFFFFFF
    return rand
}